<?php

/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\Newsletter\Controller\Index;

/**
 * Responsible for loading page content.
 *
 * This is a basic controller that only loads the corresponding layout file. It may duplicate other such
 * controllers, and thus it is considered tech debt. This code duplication will be resolved in future releases.
 */
class MailChimpDeleteSubscriber extends \Magento\Framework\App\Action\Action {

    protected $_subscriberFactory;

    public function __construct(
    \Magento\Framework\App\Action\Context $context, \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
    ) {
        $this->_subscriberFactory = $subscriberFactory;
        parent::__construct($context);
    }

    public function execute() {

        $params = $this->getRequest()->getParams();

        if (count($params) > 0) {
            $subscriber = $this->_subscriberFactory->create()->loadByEmail($params["data"]["email"]);
            $subscriber->setCheckCode($subscriber->getCode())->unsubscribe();


            \Magento\Framework\App\ObjectManager::getInstance()
                    ->get('Psr\Log\LoggerInterface')->debug(print_r($subscriber->getEmail() . " unsubscribed from mailchimp", true));
        }


        return null;
    }

}
